#include <iostream>
#include <set>
using namespace std;
long long  proizvodCifara(long long a)
{
    long long proizvod =1;
    while(a>0)
    {
        proizvod = proizvod*(a % 10);
        a = a/10;
        if (proizvod == 0)
            return 0;
    }
    return proizvod;
}
int main()
{

    int t;
    cin>>t;
    long long n[t];
    for(int i  =  0; i  < t;  i  ++)
        cin>>n[i];
    set <long long>  a;
    for(int k = 0;  k < t; k ++)
    {


        if(k  == 0)
            for(int i = 1; i  <=  n[k]; i ++)
                a.insert(proizvodCifara(i));
        else if(n[k] >=  n[k-1])
            for(int i = n[k-1]; i  <=  n[k]; i ++)
                a.insert(proizvodCifara(i));

        cout<<a.size()<<endl;
    }
    return 0;
}